<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Finder.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Finder.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * Finder
 * Created by jasonlin on 8/7/14.
 */

define(['underscore', 'jquery', 'uweaver/lang',
    'uweaver/widget/Widget', 'uweaver/widget/Form', 'uweaver/widget/Triggerbox',
    'uweaver/validator', 'uweaver/converter', 'uweaver/string',
    'uweaver/Logger'], function (_, $, lang, Widget, Form, Triggerbox, validator, converter, string, Logger) {

    var declare = lang.declare;
    var i18n = uweaver.i18n;

    var Base = Widget;

    var Finder = declare(Base, {
        /**
         * constructors
         */
        initialize: initialize,

        /**
         * public interfaces
         */
        perform: perform,
        search: search,
        fetch: fetch,
        reset: reset,
        select: select,
        selection: selection,
        criteria: criteria,
        firstPage: firstPage,
        previousPage: previousPage,
        nextPage: nextPage,
        refresh: refresh,
        getCriteria: getCriteria,
        setCriteria: setCriteria,

        /**
         * protected members
         */
        logger: new Logger("Finder"),
        prepare: prepare,

        store: store,
        page: page,
        pages: pages,
        pageSize: pageSize,
        filter: filter,

        /**
         * private members
         */
        _form: undefined,


        /**
         * event handlers
         */
        events: {
            "click [data-uw-gear=list] > tbody > tr": "onSelect",
            "change [data-uw-gear=page]": "onChange"
        },

        onFormExecute: function(command, event) {
            this.perform(command);
        },

        onToolbarPerform: function (command, event) {
            this.perform(command);
        },

        onSelect: function(event) {
            event.preventDefault();

            var $target = $(event.currentTarget);

            $target.toggle();
        },

        onChange: function(event) {
            event.preventDefault();

            var $target = $(event.currentTarget);
            var page = $target.val();
            this.page(page);
        }
    });

    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        this._markers = {
            form: {},
            toolbar: [],
            store: {},
            $criteria: undefined,
            $list: undefined,
            $page: undefined,
            $pages: undefined,
            $total: undefined
        };

        this.cache.store = config.store;
    }

    function prepare() {

        Base.prototype.prepare.apply(this, arguments);

        var markers = this._markers;

        markers.$list = this.$gear('list');
        markers.$list.css('display', 'table');
        markers.$list.css('cursor', 'pointer');
        markers.$page = this.$gear("page");
        markers.$pages = this.$gear("pages");
        markers.$total = this.$gear("total");
        markers.$criteria = this.$gear('criteria');

        //this.translate(this.$('legend, label, th, button, input, var'));

        var form = new Form({
            el:this.$gear('criteria')
        });
        form.render({enhance: false});
        this.listenTo(form, 'all', _.bind(this.onFormExecute, this));
        this._form = form;

        var $toolbars = this.$gear('toolbar');
        _.each($toolbars, function($toolbar) {
            var toolbar = new Triggerbox({
                el: $toolbar
            });
            toolbar.render({enhance: false});
            this.listenTo(toolbar, 'all', _.bind(this.onToolbarPerform, this));
            cache.toolbar.push(toolbar);
        }, this);


        this.page(1);
    }

    function store() {
        var cache = this.cache;
        return cache.store;
    }

    function filter() {
        var store = this.store();

        return store.filter();
    }

    function page(value) {
        var store = this.store();

        if(!value) return store.page();

        this.fetch({
            page: value
        });
    }

    function fetch(options) {
        var cache = this.cache;
        var store = this.store();

        options = options || {};

        store.fetch(options).done(function(response) {
            var $list = cache.$list;
            var $page = cache.$page;
            var $pages = cache.$pages;
            var $total = cache.$total;

            var $columns = $list.find('thead tr th');

            var tpl = "";
            var fields = {};
            $columns.each(function(index, column) {
                var $column = $(column);
                var name = $column.attr('name');
                var style = $column.attr('data-uw-style');
                var format = $column.attr('data-uw-format');
                tpl = tpl + "&lt;td style='" + style + "'>&lt;%-" + name + "%>&lt;/td>";
                fields[name] = format;
            });
            tpl = tpl + "";
            var template = _.template(tpl);

            var html = "&lt;tbody>";
            store.each(function(item) {
                var values = {};
                _.each(fields, function(format, name) {
                    values[name] = string.format(item.get(name), format);
                });
                html = html + "&lt;tr data-uw-id='" + item.id + "'>" + template(values) + "&lt;/tr>";
            }, this);
            html = html + "&lt;/tbody>";

            $list.find('tbody').remove();
            $list.append(html);
            $page.val(store.page());
            $pages.text(store.pages());
            if(store.total()==0) {
                $total.text(i18n.translate("No data to display"));
            } else {
                var str = i18n.translate("Total: ${0} records");
                $total.text(string.substitute(str, store.total()));
            }

            $list.table('rebuild');

            this.setCriteria(store.filter());

        }, this);
    }

    function pages() {
        return this.store().pages();
    }

    function pageSize() {
        return this.store().pageSize();
    }

    function criteria(item) {
        if(!item) return this.getCriteria();

        return this.setCriteria(item);
    }

    function getCriteria() {
        var cache = this.cache;
        var values = {};
        var fields = cache.$criteria.find('input');

        fields.each(function(index, field) {
            var $field = $(field);
            var op = $field.attr('data-uw-operand') || "eq";
            var value = converter.convert($field.val(), $field.attr("type"));

            if(value) {
                values[$field.attr('name') + "." + op] = value;
            }
        });

        return values;
    }

    function setCriteria(item) {
        var cache = this.cache;
        var values = {};
        var form = cache.form;
        _.each(item, function(value, key) {
            var name = key.split("\.")[0];

            values[name] = value;
        }, this);

        form.values(values);
    }

    function select() {

    }

    function selection() {
        var cache = this.cache;
        var store = this.store();
        var rows = cache.$list.find('tr');

        var items = [];
        rows.each(_.bind(function(index, element) {
            var $element = $(element);
            if($element.mark()) {
                var item = store.get($element.attr('data-uw-id'));
                items.push(item);
            }
        }, this));

        return items;

    }

    function perform(command) {
        switch(command.toUpperCase()) {
            case Finder.COMMAND.SEARCH:
                this.search();
                break;
            case Finder.COMMAND.RESET:
                this.reset();
                break;
            case Finder.COMMAND.FIRSTPAGE:
                this.firstPage();
                break;
            case Finder.COMMAND.PREVIOUSPAGE:
                this.previousPage();
                break;
            case Finder.COMMAND.NEXTPAGE:
                this.nextPage();
                break;
            case Finder.COMMAND.REFRESH:
                this.refresh();
                break;
            default:
                var event = {
                    context: this,
                    data: this.selection()
                };

                this.trigger(command, event);
                break;
        }
    }

    function search() {
        var cache = this.cache;
        var form = cache.form;

        if(!form.validate({prompt:true, mark:true})) {
            form.enable();
            return;
        }

        this.fetch({
            page: 1,
            filter: this.criteria()
        });
    }

    function reset() {
        var cache = this.cache;
        var form = cache.form;

        form.reset();

        this.fetch({
            page: 1,
            filter: {}
        });
    }

    function firstPage() {
        this.page(1);
    }

    function previousPage() {
        this.page(this.page() - 1);
    }

    function nextPage() {
        this.page(this.page() + 1);
    }

    function refresh() {
        this.fetch();
    }


    // Enumeration of build in commands
    Finder.COMMAND = {
        SEARCH: 'SEARCH',
        RESET: 'RESET',
        FIRSTPAGE: 'FIRSTPAGE',
        PREVIOUSPAGE: 'PREVIOUSPAGE',
        NEXTPAGE: 'NEXTPAGE',
        REFRESH: 'REFRESH'
    };
    return Finder;
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
